using System;
using System.Collections;
using System.Text;

namespace DataProvider
{
    public class VirtualDataSource
    {
        private int rowCount;
        private int colCount;
        private ArrayList rowObjects;
        private ArrayList columnsHeaders;

        public int RowCount
        {
            get { return rowCount; }
        }

        public int ColCount
        {
            get { return colCount; }
        }

        public ArrayList RowObjects
        {
            get { return rowObjects; }
        }

        public ArrayList ColumnsHeaders
        {
            get { return columnsHeaders; }
        }

        public VirtualDataSource()
        {
            RowObject aRowObject = new RowObject();
            this.rowObjects = new ArrayList();
            this.rowObjects.Add(aRowObject);
            this.rowCount = rowObjects.Count;
            this.colCount = 1;
        }

        public void AddNewRowObject()
        {
            if (this.columnsHeaders == null)
            {
                this.columnsHeaders = new ArrayList();
                this.generateColumnHeaders(this.colCount);
            }
            
            RowObject aNewRowObject = new RowObject(this.colCount);
            this.rowObjects.Add(aNewRowObject);
            this.rowCount = this.rowObjects.Count;
        }

        public VirtualDataSource(int ColumnCount)
        {
            if (ColumnCount > 0)
            {
                this.columnsHeaders = new ArrayList();
                this.generateColumnHeaders(ColumnCount);

                RowObject aRowObject = new RowObject(ColumnCount);
                this.rowObjects = new ArrayList();
                this.rowObjects.Add(aRowObject);
                this.rowCount = rowObjects.Count;
                this.colCount = ColumnCount;
            }
        }

        public void RemoveRowObject(int Index)
        {
            this.rowObjects.RemoveAt(Index);
            this.rowCount = this.rowObjects.Count;
        }

        private void generateColumnHeaders(int ColumnCount)
        {
            for (int i = 0; i < ColumnCount; i++)
            {
                string prefix = "Column";
                string suffix = i.ToString();
                string colNameString = prefix + suffix;
                char[] columnName = colNameString.ToCharArray();
                String aColumn = new String(columnName);
                this.ColumnsHeaders.Add(aColumn);
            }
        }
    }

    public class RowObject 
    {
        private ArrayList rowElements;
        public ArrayList RowElements 
        {
            get { return rowElements; }
        }

        public RowObject()
        {
            this.rowElements = new ArrayList();
            RowElement aRowElement = new RowElement();
            this.rowElements.Add(aRowElement);
        }

        public RowObject(int ColumnCount)
        {
 
            this.rowElements = new ArrayList();
            for (int i = 0; i < ColumnCount; i++)
            {
                RowElement aRowElement = new RowElement();
                this.rowElements.Add(aRowElement);
            }
        }
    }

    public class RowElement 
    {
        string rowElementData;
        public string RowElementData 
        {
            get { return rowElementData; }
            set { rowElementData = value; }
        }
        public RowElement()
        {
            this.rowElementData = "";
        }
    }
}
